class InventoryItem
{
  int countofObjectsCreated; // instance variable to track how many instances are constructed

  InventoryItem(int i)
  {
    countofObjectsCreated = i;
    System.out.println("The count in the constructor is now " + i);
    // IF THE CONSTRUCTOR ALSO BUILDS A STRING, MEMORY NEEDS TO BE FREED MORE OFTEN
  }

  // the JVM calls this override just before garbage collection recycles memory
  protected void finalize()
  {
    System.out.println("The JVM is about to recycle memory after creating this many objects: " + countofObjectsCreated);
  }

  // method to generate an object that takes runtime arg so that we cantrack how many objects have been created
  void objectGenerator(int countofObjectsCreated)
  {
    InventoryItem myObject = new InventoryItem(countofObjectsCreated);
  }
}

class AutomaticMemoryManagementDemo
{
  public static void main(String[] args)
  {
    int count;

    InventoryItem anInventoryItem = new InventoryItem(0);

    // JVM will clean up objects periodically, but not under our control
    for(count=1; count < 600000; count++)
    {
		anInventoryItem.objectGenerator(count);
	}
  }
}